"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var chai_1 = require("chai");
var fs = require("fs-extra");
var file_per_content_type_1 = require("./file_per_content_type");
describe('FilePerContentTypeRunner', function () {
    describe('run', function () {
        afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
            var _i, _a, f;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, fs.pathExists('db/migrate')];
                    case 1:
                        if (!_b.sent()) return [3 /*break*/, 8];
                        _i = 0;
                        return [4 /*yield*/, fs.readdir('db/migrate')];
                    case 2:
                        _a = _b.sent();
                        _b.label = 3;
                    case 3:
                        if (!(_i < _a.length)) return [3 /*break*/, 6];
                        f = _a[_i];
                        return [4 /*yield*/, fs.remove("db/migrate/" + f)];
                    case 4:
                        _b.sent();
                        _b.label = 5;
                    case 5:
                        _i++;
                        return [3 /*break*/, 3];
                    case 6: return [4 /*yield*/, fs.rmdir('db/migrate')];
                    case 7:
                        _b.sent();
                        _b.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        }); });
        it('writes timestamped file for each content type', function () { return __awaiter(_this, void 0, void 0, function () {
            var instance, files;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fs.mkdirp('db/migrate')];
                    case 1:
                        _a.sent();
                        instance = new file_per_content_type_1.FilePerContentTypeRunner('db/migrate', 'HEADER!!!\n', 'FOOTER!!!\n');
                        return [4 /*yield*/, instance.init()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, instance.run(['ct-a', 'ct-b', 'ct-c'], function (id, write, ctx) {
                                return write('test:' + id);
                            })];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, instance.close()];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, fs.readdir('db/migrate')];
                    case 5:
                        files = _a.sent();
                        chai_1.expect(files.length).to.eq(3);
                        chai_1.expect(files[0]).to.match(/[0-9]+_generated_from_diff\.ts/);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
